<template>

   <b-container fluid>
     <center v-if="carrousselMaps.length>0"><h1>A la Une</h1></center>
     <b-carousel v-if="carrousselMaps.length>0"
      id="carousel-1" class="mt-2"
      v-model="slide"
      controls
      :interval="400000"
      no-animation
      indicators
      background="#ababab"
      img-width="1024"
      img-height="480">
      <b-carousel-slide v-for="map in carrousselMaps" :key="map.id">
         <h1><a @click="openApp(map)" v-b-tooltip.hover title="Ouvrir l'application">
              {{map.display_name}}</a></h1>
        <template #img>
          <div class="imageContainer">
          <img
            class="d-block img-fluid w-100"
            :src="getThumbnailUrl(map)"
            alt="image slot">
          </div>
        </template>
      </b-carousel-slide>
      </b-carousel>

      <b-form-row class="search-row">
        <b-col cols="10">
          <b-form-input v-model="searchTxt" placeholder="Rechercher"
            @input="loadMaps()"></b-form-input>
        </b-col>
        <b-col cols="2">
          <b-button @click="loadMaps()" class="bg_color-first w-100">
              <b-icon icon="search"></b-icon>
          </b-button>
        </b-col>
      </b-form-row>

      <b-alert show v-if="noResultsFound">Aucun Résultat trouvé</b-alert>
      <b-card-group deck v-for="mapline in maps" :key="mapline.id">
        <b-card v-for="map in mapline" :key="map.id"
          :title="map.display_name"
          :img-src="getThumbnailUrl(map)"
          @click="openApp(map)"
          img-alt="Image"
          tag="article"
          class="mb-2">
          <div class="badge-over-img">
            <b-badge href="#" variant="primary" v-b-tooltip.hover title="Carte de mon organisation">
              <b-icon v-if="isMapOfMyOrga(map)" icon="people-fill"></b-icon>
            </b-badge>
          </div>
          <!-- <b-icon v-if="!map.public" icon="people" variant="primary"></b-icon> -->
          <b-card-text>
           {{map.description}}
          </b-card-text>
        </b-card>
      </b-card-group>
      <div class="mt-3 mb-5">
      <b-pagination v-if="rows>0" v-model="currentPage" :total-rows="rows" :per-page="perPage"
      @change="pageChange($event)"
      align="center"></b-pagination>
    </div>
   </b-container>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Application from '@/models/map-context/Application';
import { EventBus, EVENTS } from '@/services/EventBus';
import Component from 'vue-class-component';
import BaseComponent from '../BaseComponent';

@Component({
  props: {
  },
})
export default class MapUserList extends BaseComponent {
  slide= 0;

  sliding = false;

  maps = [];

  carrousselMaps = [];

  searchTxt = '';

  currentPage = 1;

  rows = 0;

  perPage = 6; // 6 cartes par page

  perLine = 3; // 3 cartes par ligne

  noResultsFound = false;

  onSlideStart(slide:any) {
    this.sliding = true;
  }

  isMapOfMyOrga(map:Application) {
    const currentAppUserGroupId = map.usergroup;
    if (this.contextService.user
      && this.contextService.user.usergroup_roles
        .filter((x:any) => x.usergroup.id === currentAppUserGroupId).length > 0) {
      return true;
    }

    return false;
  }

  onSlideEnd(slide:any) {
    this.sliding = false;
  }

  pageChange(page:number) {
    this.currentPage = page;
    this.loadMaps();
  }

  listToMatrix(list:Array<any>, elementsPerSubArray:number) {
    const matrix :any = [];
    let i; let k;

    for (i = 0, k = -1; i < list.length; i += 1) {
      if (i % elementsPerSubArray === 0) {
        k += 1;
        matrix[k] = [];
      }

      matrix[k].push(list[i]);
    }

    return matrix;
  }

  loadMaps():void {
    this.noResultsFound = false;
    this.contextService.getMaps(this.searchTxt, this.currentPage, this.perPage).then((res) => {
      console.log(res);
      if (res.data && res.data.count > 0) {
        this.rows = res.data.count;
        this.maps = this.listToMatrix(res.data.results, this.perLine);
      } else {
        this.rows = 0;
        this.maps = [];
        this.noResultsFound = true;
      }
    });
  }

  mounted() {
    console.log('map list');
    /*
    this.contextService.getFavoriteMaps().then((res) => {
      console.log(res);
      if (res.data && res.data.count > 0) {
        this.carrousselMaps = res.data.results;
      }
    }).catch((error) => { EventBus.$emit(EVENTS.ERROR, error); });
    */
    this.loadMaps();
  }

  removeApp(map:Application) {
    this.contextService.removeApp(map);
  }

  openApp(map:Application) {
    this.$router.push({ path: `/map/${map.id}` });
  }

  getThumbnailUrl(map:Application) :string {
    if (map.thumbnail != null) {
      return this.contextService.getThumbnailUrl(map);
    }

    return `https://picsum.photos/1024/480/?image=${map.id}`;
  }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";

.carousel-item{
  min-height: 480px;
}
.imageContainer{
  width:100%;
  height: 480px;
  display: flex;
  justify-content: center; /* align horizontal */
  align-items: center; /* align vertical */
}
a{
  cursor: pointer;
}
.search-row {
  margin: 2rem .75rem 2rem 0;
}

@media (max-width:575.8px) {
  .search-row {
    margin: 1rem 0 1rem 0;
  }
}

.card-deck .card {
  box-shadow: 0 6px 12px rgba(129,128,128,.1);
  border: none;
}

@media (min-width:576px) {
  .card-deck .card { //* keep the same size than other cards, when there isn't 3 in a row
    max-width: calc(33% - 30px);
  }
}

.card-body {
  position: relative;
}
.badge-over-img {
  position: absolute;
  top: -34px;
  right: 0;
  padding: 12px 10px 8px 10px;
  width: 100%;
  min-height: 38px;
  display: flex;
  justify-content: flex-end;
  background: linear-gradient(
    0deg, #ffffff 0%, rgba(255, 255, 255, 0.5) 50%, rgba(255, 255, 255, 0) 100%
  );
}

.card-text {
  max-height: 100px;
  overflow-y: auto;
}
article img{
  height: 150px;
  width: auto;
  margin: 6px 6px 0 6px;
  background: #e6f3ff;
  color: white;
  text-align: center;
}
article{
  overflow: clip;
  cursor:pointer;
}

h4 {
  color: @first;
  border: none;
  font-weight: bold;
}
</style>
